# Shared Makefile targets for individual kubebuilder projects

# Note(joe): this include is relative to the Go project Makefile.
include ../Makefile.go.mk

##@ Kubebuilder specific stuff below here
# Keep this up to date with kubebuilder skaffolding

# K8S_VERSION refers to the version of K8s we want to dev against.
# This is used for envtest and when creating kind clusters locally and needs to be compatible with both.
# Keep this roughly in sync with cloud provider default versions (GKE/EKS)
K8S_VERSION = 1.25.3

KIND_IMAGE = kindest/node:v$(K8S_VERSION)

GINKGO := go run github.com/onsi/ginkgo/v2/ginkgo

# Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
ifeq (,$(shell go env GOBIN))
GOBIN=$(shell go env GOPATH)/bin
else
GOBIN=$(shell go env GOBIN)
endif

##@ General

# The help target prints out all targets with their descriptions organized
# beneath their categories. The categories are represented by '##@' and the
# target descriptions by '##'. The awk commands is responsible for reading the
# entire set of makefiles included in this invocation, looking for lines of the
# file as xyz: ## something, and then pretty-format the target and help. Then,
# if there's a line with ##@ something, that gets pretty-printed as a category.
# More info on the usage of ANSI control characters for terminal formatting:
# https://en.wikipedia.org/wiki/ANSI_escape_code#SGR_parameters
# More info on the awk command:
# http://linuxcommand.org/lc3_adv_awk.php

.PHONY: help
help: ## Display this help.
	@awk 'BEGIN {FS = ":.*##"; printf "\nUsage:\n  make \033[36m<target>\033[0m\n"} /^[a-zA-Z_0-9-]+:.*?##/ { printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2 } /^##@/ { printf "\n\033[1m%s\033[0m\n", substr($$0, 5) } ' $(MAKEFILE_LIST)

##@ Development

.PHONY: manifests-default
manifests-default: ## Generate WebhookConfiguration, RBAC and CustomResourceDefinition objects.
	$(CONTROLLER_GEN) rbac:roleName=manager-role crd:maxDescLen=0 webhook paths="./..." output:crd:artifacts:config=config/crd/bases

.PHONY: generate
generate: ## Generate code containing DeepCopy, DeepCopyInto, and DeepCopyObject method implementations.
	$(CONTROLLER_GEN) object:headerFile="hack/boilerplate.go.txt" paths="./..."

.PHONY:
regenerate: manifests generate

.PHONY: test
test: manifests generate fmt vet ## Run tests.
	@# Note(joe): use envtest most compatible k8s version.
	@# from envtest help: 1.17 # any release 1.17.x or below.
	KUBEBUILDER_ASSETS="$(shell $(ENVTEST) use "<$(K8S_VERSION)" -p path)" \
		go test -ldflags "$(GO_BUILD_LDFLAGS)" -v ./controllers/... -coverprofile cover.out

##@ Kubebuilder Build Dependencies

## Location to install dependencies to
LOCALBIN ?= $(shell pwd)/bin
$(LOCALBIN):
	mkdir -p $(LOCALBIN)

## Tool Binaries
CONTROLLER_GEN ?= go run sigs.k8s.io/controller-tools/cmd/controller-gen
ENVTEST ?= go run sigs.k8s.io/controller-runtime/tools/setup-envtest
